Subject: Re: [PATCH V2] powerpc/mm: don't do tlbie for updatepp request with NO HPTE fault

From: "Aneesh Kumar K.V" <[email-masked]>
Date: Wed, 03 Dec 2014 19:59:52 +0530

Michael Ellerman <[email-masked]> writes:

> On Tue, 2014-12-02 at 12:20 +0530, Aneesh Kumar K.V wrote:
>> upatepp get called for a nohpte fault, when we find from the linux
>> page table that the translation was hashed before. In that case
>> we are sure that there is no existing translation, hence we could
>> avoid doing tlbie.
>
> Same comments as last time.
>
> http://patchwork.ozlabs.org/patch/406219/

I replied to that review feedback right ? 

   > We are sure there *was* no existing translation. It's possible that since the
   > nohpte fault occurred the translation has been loaded into the tlb.
   >
   > Ben says that's OK, because updatepp is only ever relaxing permissions. But
   > please add some explanation of that to the changelog - it's not obvious.

I am not sure what we need to document. We look at pte bits to determine
the access bits in hpte, so even if we race and miss the tlbie, we
should have the right permissions. Or are you suggesting that we capture
in commit message that, even if we have parrallel fault, we should be
ok if we skip the tlbie ? Or do you want to capture the fact that
mprotect won't call updatepp, because that involve a
ptep_modify_prot_start which cause a hpte invalidate and not updatepp ?

   > The context preceeding this hunk includes this comment:
   >
   > 	/*
   > 	 * We need to invalidate the TLB always because hpte_remove doesn't do
   > 	 * a tlb invalidate. If a hash bucket gets full, we "evict" a more/less
   > 	 * random entry from it. When we do that we don't invalidate the TLB
   > 	 * (hpte_remove) because we assume the old translation is still
   > 	 * technically "valid".
   > 	 */
   >
   > Which seems out of sync with the code now.

The comment is still valid. What it explain is the part that, even if we
didn't find hash pte matching we still need to do a tlbie. We don't look
at the nohpte fault details in the comment.

-aneesh